package cn.com.infosec.util.encoders;

import java.io.OutputStream;

public class HexEncoder implements Encoder {
   protected final byte[] encodingTable = new byte[]{48, 49, 50, 51, 52, 53, 54, 55, 56, 57, 97, 98, 99, 100, 101, 102};
   protected final byte[] decodingTable = new byte[128];

   public HexEncoder() {
      this.initialiseDecodingTable();
   }

   private boolean ignore(char c) {
      return c == '\n' || c == '\r' || c == '\t' || c == ' ';
   }

   protected void initialiseDecodingTable() {
      byte[] var2;
      for(int var1 = 0; var1 < (var2 = this.encodingTable).length; ++var1) {
         byte var3 = var2[var1];
         this.decodingTable[var3] = (byte)var1;
      }

      byte[] var10000 = this.decodingTable;
      var10000[65] = var10000[97];
      var10000[66] = var10000[98];
      var10000[67] = var10000[99];
      var10000[68] = var10000[100];
      var10000[69] = var10000[101];
      var10000[70] = var10000[102];
   }

   public int encode(byte[] data, int off, int length, OutputStream out) {
      for(int var5 = off; var5 < off + length; ++var5) {
         int var6 = data[var5] & 255;
         out.write(this.encodingTable[var6 >>> 4]);
         out.write(this.encodingTable[var6 & 15]);
      }

      return length * 2;
   }

   public int decode(byte[] data, int off, int length, OutputStream out) {
      int var5 = 0;

      for(length += off; length > off && this.ignore((char)data[length - 1]); --length) {
      }

      while(off < length) {
         while(off < length && this.ignore((char)data[off])) {
            ++off;
         }

         byte var6;
         for(var6 = this.decodingTable[data[off++]]; off < length && this.ignore((char)data[off]); ++off) {
         }

         byte var10001 = var6;
         var6 = this.decodingTable[data[off++]];
         out.write(var10001 << 4 | var6);
         ++var5;
      }

      return var5;
   }

   public int decode(String data, OutputStream out) {
      int var3 = 0;

      int var4;
      for(var4 = data.length(); var4 > 0 && this.ignore(data.charAt(var4 - 1)); --var4) {
      }

      for(int var5 = 0; var5 < var4; ++var3) {
         while(var5 < var4 && this.ignore(data.charAt(var5))) {
            ++var5;
         }

         byte var6;
         for(var6 = this.decodingTable[data.charAt(var5++)]; var5 < var4 && this.ignore(data.charAt(var5)); ++var5) {
         }

         byte var10001 = var6;
         var6 = this.decodingTable[data.charAt(var5++)];
         out.write(var10001 << 4 | var6);
      }

      return var3;
   }
}
